/*************************************
 *     *     TIME:20202.04.25
 *     Development Team: MYLS Technology Co.
 *     Mini Smart Car Robot
 *     מצב שליטה בשלט  אינפרא אדום        
 *     זכור!  יש להתקין קודם את הספריות של אירפרא אדום
 * 
 **************************************/
#include <IRremote.h>
#include <IRremoteInt.h>

//------- IR REMOTE CODES ---------//
#define FORWARD 0xFF18E7   //16718055  
#define BACK    0xFF4AB5    //16730805
#define LEFT    0xFF10EF    //16716015
#define RIGHT   0xFF5AA5    //16734885
#define  STOP   0xFF38C7    //16726215  OK Key
#define Buzzer  0xFFB04F    //16738455  # key
#define  IR      0xFFA25D    //16734885   1 key
#define  AVOID   0xFF629D    //16726215   2 key
#define  MAIN    0xFF6897     //16726215  * key

#define RECV_PIN  2


//Define the direction of car movement
#define  Stop     0
#define  Forward  1
#define  Back     2
#define  Left     3
#define  Right    4

//Definition of ultrasonic pin
#define  Trig A4 
#define  Echo A5

//Data variable definition
int MotSpeed1 = 0; 
int MotSpeed2 = 0;
int Speed_adjustment = 120;
int stop_bit = 0;
int flag=0;
//Program initialization
int D1 = 5;      // Definition of IO port
int D2 = 6;       
int D3 = 9;      
int D4 = 10;

IRrecv irrecv(RECV_PIN);
decode_results results;
unsigned long val;
unsigned long preMillis;
void forward()
{
  digitalWrite(D1, LOW);
  digitalWrite(D2, HIGH);
  digitalWrite(D3, LOW);
  digitalWrite(D4, HIGH);
}
void back()
{
  digitalWrite(D1, HIGH);
  digitalWrite(D2, LOW);
  digitalWrite(D3, HIGH);
  digitalWrite(D4, LOW);
}
void right()
{
  digitalWrite(D1, LOW);
  digitalWrite(D2, LOW);
  digitalWrite(D3, LOW);
  digitalWrite(D4, HIGH);
}
void left()
{
  digitalWrite(D1, LOW);
  digitalWrite(D2, HIGH);
  digitalWrite(D3, LOW);
  digitalWrite(D4, LOW);
}
void stop_it()
{
  digitalWrite(D1, LOW);
  digitalWrite(D2, LOW);
  digitalWrite(D3, LOW);
  digitalWrite(D4, LOW);
}
  

void setup()  
{
    Serial.begin(9600); 
    irrecv.enableIRIn();
    pinMode(D1, OUTPUT);
    pinMode(D2, OUTPUT);
    pinMode(D3, OUTPUT);
    pinMode(D4, OUTPUT);

    pinMode(Trig,OUTPUT);   
    pinMode(Echo,INPUT); 
     stop_it();
 
    // Define ultrasonic sensor pins
    

}

//Principal function
void loop()
{   
    if (irrecv.decode(&results)){ 
    preMillis = millis();
     val = results.value;
     Serial.println(val, HEX); 
     irrecv.resume();
     switch(val){
      case IR: { flag=1; remote();  break; }
      case AVOID:  { flag=2;  delay(500); avoidance(18);     break; }
      default:                  break;
    }
  

  }
  }

/*
Function: obtain ultrasonic sensor ranging data
Parameters: Trig, Echo
Parameter description: sensor connected to the motherboard pin port A4,A5
Trig -------> pin A4
Echo -------> pin A5
*/
void remote(){
  Serial.print("remote mode");
  while (flag==1) 
  {
  if (irrecv.decode(&results)){ 
    preMillis = millis();
    val = results.value;
    Serial.println(val, HEX); 
    irrecv.resume();
     switch(val){
      case FORWARD: forward();  break;
      case BACK:    back();     break;
      case LEFT:    left();     break;
      case RIGHT:   right();    break;
      case STOP:   stop_it();    break;
      case AVOID:   {
                      flag=2;  delay(500);
                      avoidance(18);   break; }
      case MAIN:   { flag=0;  stop_it();     break; }  
      
      default:                  break;
    }
  

  }
  }
}

float GetDistance()
{
    float distance;
  
	digitalWrite(Trig, LOW); 
	delayMicroseconds(2); 
	digitalWrite(Trig, HIGH); 
	delayMicroseconds(10);
	digitalWrite(Trig, LOW);

    distance = pulseIn(Echo, HIGH) / 58.00;
     
	return distance;  //Return distance
}

/*
* Function: Obstacle avoidance
* Parameter: set_dis sets the obstacle avoidance distance
*/

//Motor 1 output definition
void motor1(int steep1, int steep2) 
{
   analogWrite(5,steep1);
   analogWrite(6,steep2); 
}

//Motor 2 output definition
void motor2(int steep1, int steep2)
{
   analogWrite(9,steep1);
   analogWrite(10,steep2); 
}

//Obstacle avoidance function
void avoidance(int set_dis)
{

  
  while(flag==2)
  { 
    if (irrecv.decode(&results)){ 
    preMillis = millis();
    val = results.value;
    Serial.println(val, HEX); 
    irrecv.resume();
    } 
    else if (val==AVOID) { delay(500); avoidance(18);  }
    else if(val==STOP)   stop_it();
    else if(val==IR)  { flag=1; remote(); }
    else if(val==MAIN){ flag=0; stop_it(); }



    else { 
          int distance;
    distance = GetDistance(); 
    Serial.println(distance);  //Print distance in serial port
    if(distance < 30)     //Judge that the distance is less than 40cm and start to decelerate
    {
	  Speed_adjustment--;
	  //delay(5);     //Car deceleration speed
	  if(Speed_adjustment<=120)Speed_adjustment=120;
      MotSpeed1 = Speed_adjustment+20;  //In order to make up for the car's yaw, a value can be added according to the actual situation //as:Speed_adjustment+20
      MotSpeed2 = Speed_adjustment;
    }

   if(distance > 30)  //Judge if the distance is more than 40cm and start to accelerate
    {
	  Speed_adjustment++;
	  //delay(5);
	  if(Speed_adjustment>=235)Speed_adjustment=235; //The maximum limit is 255
      MotSpeed1 = Speed_adjustment+20; //In order to make up for the car's yaw, a value can be added according to the actual situation //as:Speed_adjustment+20
      MotSpeed2 = Speed_adjustment;
    }
     
	if(distance < set_dis)  //Judge that the car is less than the obstacle avoidance distance and start to turn backward
	{
		delay(10);
		distance = GetDistance(); 
		if(distance < set_dis)
		{
			if(stop_bit==0)
			{
				motor(Stop,0,0);//stop
				delay(300);
				stop_bit=1;
			}
			motor(Back,140,140); //Car back
			delay(600);
			motor(Left,140,140); //The car turns left
			delay(200);          
			Speed_adjustment=120;
		}
	}
    else
    {
        motor(Forward,MotSpeed1,MotSpeed2);//If there is no less than the obstacle avoidance distance, move forward
		stop_bit=0;
    }
    } // else
} //while 
}

//Motor direction function to determine the direction of the car
void motor(int dir ,int speed1, int speed2)  
{  
    switch (dir)
    {
    case Stop:
        motor1(0, 0);
        motor2(0, 0);
       
        break;

    case Forward:  //Go ahead
       
       motor1(0,speed1); //If the circuit is not connected correctly, modify here to correct the motor direction
       motor2(0,speed2); 
       
        break;

    case Back:  //Back up
        
        motor1(speed1, 0);
        motor2(speed2, 0);
        
        break;

    case Left:   //Turn left
        motor1(0, speed1);
        motor2(speed1, 0);
        
        break;

    case Right:   //Turn right
        
        motor1(speed1, 0);
        motor2(0, speed2);
       
        break;
    
    default:
        break;
    }
}
